/*
 * Header File < graphix.h >
 *
 * Enhanced Functions: Borland Graphics Interface for Xlib
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _GRAPHIX_H_
#define _GRAPHIX_H_

#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include "graphics.h"

struct rgbtype {
  unsigned short r, g, b;
};
struct fontstruct {
 XFontStruct *font;
 int flag;
};
struct fontset {
 XFontSet font;
 int flag;
};

typedef struct _xbgi {
  int argc;
  char **argv;
  int id;
  Display *dpy;
  Visual *vis;
  int scr;
  int depth;
  int vclass;
  Window root;
  Window *win;
  int only_ank_flag;
  struct fontstruct chr[MAX_CHAR_FONT+1][MAX_CHAR_SIZE+1];
  struct fontstruct bchr0[2][MAX_CHAR_SIZE+1];
  struct fontset mchr0[MAX_CHAR_SIZE+1];
  GC gc;
  unsigned long fg, bg, lc, dc;
  XFontStruct *fs;
  XEvent button_press_ev, button_release_ev, mouse_motion_ev;
  XEvent page_enter_ev, page_leave_ev, key_press_ev;
  XEvent configure_ev, expose_ev;
  int (*button_press_proc)  ( int b, int x, int y );
  int (*button_release_proc)( int b, int x, int y );
  int (*mouse_motion_proc)  ( int b, int x, int y );
  int (*page_enter_proc)    ( int p );
  int (*page_leave_proc)    ( int p );
  int (*key_press_proc)     ( int c );
  int (*configure_proc)     ( void );
  int (*expose_proc)        ( void );
  int (*noevent_proc)       ( void );
  Colormap colormap;
  unsigned char colortable[256];
  unsigned long pixels[MAXCOLORS+1];
  GC gcdraw, gcfill, gcpixel, gcimage;
  int gdriver, gmode, gerror;
  int npage, apage, vpage;
  int ncolor, color, bkcolor;
  struct pointtype cp;
  struct viewporttype viewport;
  struct linesettingstype lineset;
  struct textsettingstype textset;
  struct fillsettingstype fillset;
  struct palettetype palette;
  struct rgbtype rgb[MAXCOLORS+1];
  struct _xbgi *next;
} xbgi;

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

extern xbgi *_creategraph(
#if NeedFunctionPrototypes
  int __argc, char *__argv[], char *__pd
#endif
);

extern xbgi *creategraph(
#if NeedFunctionPrototypes
  int *__graphdriver, int *__graphmode, char *__pathtodriver
#endif
);

extern xbgi *thisgraph(
#if NeedFunctionPrototypes
  void
#endif
);

extern void destroygraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

extern void currentgraph(
#if NeedFunctionPrototypes
  xbgi *__this
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* _GRAPHIX_H_ */
