/*
 * header file of jmskanji < jstring.h >
 *
 * for libjmskanji.a on unix
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */

#if !defined( __JSTRING_H )
#define __JSTRING_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#ifndef NeedFunctionPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define NeedFunctionPrototypes 1
#else
#define NeedFunctionPrototypes 0
#endif /* __STDC__ */
#endif /* NeedFunctionPrototypes */

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
char  *jstrncpy (
#if NeedFunctionPrototypes
  char  *__dest, const char  *__src, size_t __maxlen
#endif
);
char  *jstrncat (
#if NeedFunctionPrototypes
  char  *__dest, const char  *__src, size_t __maxlen
#endif
);
char  *jstrchr  (
#if NeedFunctionPrototypes
  const char  *__s, unsigned short __c
#endif
);
char  *jstrrchr (
#if NeedFunctionPrototypes
  const char  *__s, unsigned short __c
#endif
);
char  *jstrtok  (
#if NeedFunctionPrototypes
  char  *__s1, const char  *__s2
#endif
);
char  *jstradv  (
#if NeedFunctionPrototypes
  const char  *__s, int __n
#endif
);
char  *jstrmatch(
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
char  *jstrskip (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
char  *jstrrev  (
#if NeedFunctionPrototypes
  char  *__s
#endif
);
char  *jstrstr  (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
int    jstrcmp  (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
int    jstricmp (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
int    jstrncmp (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2, size_t __maxlen
#endif
);
int    jstrnicmp(
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2, size_t __maxlen
#endif
);
size_t jstrlen  (
#if NeedFunctionPrototypes
  const char  *__s
#endif
);
char  *jstrupr  (
#if NeedFunctionPrototypes
  char  *__s
#endif
);
char  *jstrlwr  (
#if NeedFunctionPrototypes
  char  *__s
#endif
);
size_t jstrcspn (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
size_t jstrspn  (
#if NeedFunctionPrototypes
  const char  *__s1, const char  *__s2
#endif
);
char  *jstrset  (
#if NeedFunctionPrototypes
  char  *__s, unsigned short __c
#endif
);
char  *jstrnset (
#if NeedFunctionPrototypes
  char  *__s, unsigned short __c, size_t __maxlen
#endif
);
int    btom     (
#if NeedFunctionPrototypes
  const char  *__s, int __nbyte
#endif
);
int    mtob     (
#if NeedFunctionPrototypes
  const char  *__s, int __nmoji
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#ifndef __CHKCTYPE
#define __CHKCTYPE

#define CT_ANK   0
#define CT_KJ1   1
#define CT_KJ2   2
#define CT_ILGL  (-1)

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

int chkctype  (
#if NeedFunctionPrototypes
  char __c, int __mode
#endif
);
int nthctype  (
#if NeedFunctionPrototypes
  const char *__s, int __nbyte
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* __CHKCTYPE */

#endif /* __JSTRING_H */
