/*
 * header file of jmskanji < jctype.h >
 *
 * for libjmskanji.a on unix
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */

#if !defined( __JCTYPE_H )
#define __JCTYPE_H

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define _KNJ_M  ((char)0x01)    /* Non-punctuation of Kana-set */
#define _KNJ_P  ((char)0x02)    /* Punctuation of Kana-set */
#define _KNJ_1  ((char)0x04)    /* Legal 1st byte of double byte stream */
#define _KNJ_2  ((char)0x08)    /* Legal 2nd btye of double byte stream */

extern char  _jctype[];   /* J-Character type array */

#ifndef NeedFunctionPrototypes
#if defined(FUNCPROTO) || defined(__STDC__) || defined(__cplusplus) || defined(c_plusplus)
#define NeedFunctionPrototypes 1
#else
#define NeedFunctionPrototypes 0
#endif /* __STDC__ */
#endif /* NeedFunctionPrototypes */

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
int iskmoji   (
#if NeedFunctionPrototypes
  int __c
#endif
);
int iskpun    (
#if NeedFunctionPrototypes
  int __c
#endif
);
int iskana    (
#if NeedFunctionPrototypes
  int __c
#endif
);
int iskata    (
#if NeedFunctionPrototypes
  int __c
#endif
);
int isalkana  (
#if NeedFunctionPrototypes
  int __c
#endif
);
int ispnkana  (
#if NeedFunctionPrototypes
  int __c
#endif
);
int isalnmkana(
#if NeedFunctionPrototypes
  int __c
#endif
);
int isprkana  (
#if NeedFunctionPrototypes
  int __c
#endif
);
int isgrkana  (
#if NeedFunctionPrototypes
  int __c
#endif
);
int iskanji   (
#if NeedFunctionPrototypes
  int __c
#endif
);
int iskanji2  (
#if NeedFunctionPrototypes
  int __c
#endif
);
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif
#define iskmoji(c)      ((_jctype+1)[(unsigned char)(c)] & _KNJ_M)
#define iskpun(c)       ((_jctype+1)[(unsigned char)(c)] & _KNJ_P)
#define iskana(c)       ((_jctype+1)[(unsigned char)(c)] & (_KNJ_M|_KNJ_P))
#define iskata(c)       ((_jctype+1)[(unsigned char)(c)] & (_KNJ_M|_KNJ_P))
#define isalkana(c)     (isalpha(c) || iskmoji(c))
#define ispnkana(c)     (ispunct(c) || iskpun(c))
#define isalnmkana(c)   (isalnum(c) || iskmoji(c))
#define isprkana(c)     (isprint(c) || iskana(c))
#define isgrkana(c)     (isgraph(c) || iskana(c))
#define iskanji(c)      ((_jctype+1)[(unsigned char)(c)] & _KNJ_1)
#define iskanji2(c)     ((_jctype+1)[(unsigned char)(c)] & _KNJ_2)
#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif
int jiszen  (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisl0   (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisl1   (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisl2   (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisalpha(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisupper(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jislower(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisdigit(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jiskana (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jiskata (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jishira (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jiskigou(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisspace(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
int jisprint(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jtolower(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jtoupper(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jtohira (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jtokana (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jtokata (
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short zentohan(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short hantozen(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jistojms(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
unsigned short jmstojis(
#if NeedFunctionPrototypes
  unsigned short __c
#endif
);
#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#ifndef __CHKCTYPE
#define __CHKCTYPE

/* values used in chkctype(), nthctype() */
#define CT_ANK  0
#define CT_KJ1  1
#define CT_KJ2  2
#define CT_ILGL (-1)

#if defined(__cplusplus) || defined(c_plusplus)
extern "C" {
#endif

int chkctype  (
#if NeedFunctionPrototypes
  char __c, int __mode
#endif
);
int nthctype  (
#if NeedFunctionPrototypes
  const char *__s, int __nbyte
#endif
);

#if defined(__cplusplus) || defined(c_plusplus)
}
#endif

#endif /* __CHKCTYPE */

#endif /* __JCTYPE_H */
