/*
 * screen control with escape sequance < escs.h >
 *
 * ץ󥹤ˤ롼
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _ESCS_H_
#define _ESCS_H_
#define ESC 0x1b

/* ɽ֤ locate */
static void locate( int x, int y )
{
  printf( "%c[%d;%dH", ESC, y, x );
}

/* ɽ() row */
static void locatex( int x )
{
  printf( "%c[;%dH", ESC, x );
}

/* ɽ() column */
static void locatey( int y )
{
  printf( "%c[%dH", ESC, y );
}

/* ̤ξõ clear screen */
static void cls( void )
{
  printf( "%c[2J", ESC );
}

/* 뤫ޤǾõ clear to end of line */
static void cleol( void )
{
  printf( "%c[K", ESC );
}

/* 뤫饹꡼νޤǾõ clear to end of screen */
static void cleos( void )
{
  printf( "%c[0J", ESC );
}

/* ԤΤϤᤫ饫ޤǾõ clear from top of line */
static void cltol( void )
{
  printf( "%c[1K", ESC );
}

/* ꡼ΤϤᤫ饫ޤǾõ clear from top of screen */
static void cltos( void )
{
  printf( "%c[1J", ESC );
}

/* Ԥκ */
static void cll( void )
{
  printf( "%c[2K", ESC );
}

/* Ԥ insert line */
static void inl( int n )
{
  printf( "%c[%dL", ESC, n );
}

/* ɽɽ set cursor on or off */
static void cursor( int on_off )
{
  if ( on_off ){
    printf( "%c[>51", ESC );
  }else{
    printf( "%c[>5h", ESC );
  }
}

/* ʸ⡼ set foreground color */
static void col( int col )
{
  printf( "%c[%dm", ESC, 30+col );
}

/* طʿ⡼ set background color */
static void bkcol( int col )
{
  printf( "%c[%dm", ESC, 40+col );
}

/*
 *  ISO  6429
 *   0: 
 *   1: 
 *   2: 
 *   3: 
 *   4: 
 *   5: ޥ
 *   6: 
 *   7: 
 */
enum ESCS_COLOR {
  ESCS_BLACK,
  ESCS_RED,
  ESCS_GREEN,
  ESCS_YELLOW,
  ESCS_BLUE,
  ESCS_MAGENTA,
  ESCS_CYAN,
  ESCS_WHITE,
};

#endif
