/*
 * functions for finding files for dos and unix < files.h >
 *
 * DOS & UNIX ߴե븡ؿ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _FILES_H_
#define _FILES_H_
#include <ctype.h>
#include <malloc.h>
#include <string.h>

/*
  ե븡ʴؿ
   0. ե̾ؿ ............... getfname( dirname )
   1. ե륹ȴؿ ............. files( dirname, n )
   2. ĥҥե븡ȴؿ ... files_suffix( dirname, suffix, n )
   *. 磻ɥɸȴؿ ... files_wild( dirname, wild, n )

  ޥɥ饤ǻꤵ줿ϥե븡ʴؿ
   1. ϥե̾ؿ ........... read_file( argc, argv )
   2. ϥե̾¤Ӽؿ ....... read_files( argc, argv, n )
 */

#if !defined(__BORLANDC__)||!defined(__TURBOC__)
#include <sys/file.h>
#include <sys/dir.h>
#else
#include <dirent.h>
#define direct dirent
#include <dos.h>
#endif

/*
 * ե̾ؿ getfname( dirname )
 *
 * : dirname ǥ쥯ȥ̾ ... NULLξ, Υե̾
 * : ե̾
 */
static char *getfname( char *dirname )
{
  static DIR *thisdir = NULL;
  struct direct *dir;
  char *ret;

  if ( dirname != NULL ){
    if ( thisdir != NULL ) closedir( thisdir );
    if ( (thisdir=opendir(dirname)) == NULL ) return NULL;
    rewinddir( thisdir );
  }
  if ( thisdir != NULL ){
    dir = readdir( thisdir );
    if ( dir != NULL ){
      ret = dir->d_name;
    }else{
      ret = NULL;
      closedir( thisdir );
      thisdir = NULL;
    }
  }else{
    ret = NULL;
  }
  return ret;
}

/* ʸ󥽡ȴؿ */
static void sort_strings( int strc, char **strv )
{
  int i, j;
  char *wk;

  for ( i=1; i<strc; i++ )
    for ( j=i-1; j>=0; j-- )
      if ( strncmp( strv[j], strv[j+1], strlen(strv[j]) ) > 0 ){
        wk = strv[j]; strv[j] = strv[j+1]; strv[j+1] = wk;
      }else
        break;
}

/*
 * ե륹ȴؿ files( dirname, n )
 *
 * : dirname ǥ쥯ȥ̾
 * : ե̾¤, n ե
 */
static char **files( char *dirname, int *n )
{
  int i, namelen;
  char *name;
  static int strc = 0;
  static char **strv = NULL;

  if ( strc != 0 && strv != NULL ){
    for ( i=0; i<strc; i++ )
      free( strv[i] );
    free( strv );
    *n = strc = 0;
    strv = NULL;
  }
  if ( dirname == NULL ){
    *n = strc = 0;
    strv = NULL;
    return strv;
  }
  if ( getfname( dirname ) == NULL ){
    *n = strc = 0;
    return strv;
  }
  name = getfname( dirname );
  while ( name != NULL ){
    strc++;
    name = getfname( NULL );
  }
  if ( strc == 0 ) {
    *n = strc;
    strv = NULL;
    return strv;
  }
  strv = (char**)malloc( strc*sizeof(char*) );
  name = getfname( dirname );
  i = 0;
  while ( name != NULL ){
    namelen = strlen( name );
    strv[i] = (char*)malloc( (namelen+1)*sizeof(char) );
    strcpy( strv[i], name );
    i++;
    name = getfname( NULL );
  }
  sort_strings( strc, strv );
  *n = strc;
  return strv;
}

/*
 * ĥҥե븡ȴؿ files_suffix( dirname, suffix, n )
 *
 * : dirname ǥ쥯ȥ̾, suffix ĥ
 * : ե̾¤, n ե
 */
static char **files_suffix( char *dirname, char *suffix, int *n )
{
  int i, extlen, namelen;
  char *name, extname[64];
  static int strc = 0;
  static char **strv = NULL;

  strcpy( extname, "." );
  if ( suffix != NULL )
    strcat( extname, suffix ); /* ĥҤꤵʤ⤢ꤦ */
  extlen = strlen( extname );
  if ( strc != 0 && strv != NULL ){
    for ( i=0; i<strc; i++ )
      free( strv[i] );
    free( strv );
    *n = strc = 0;
    strv = NULL;
  }
  if ( dirname == NULL ){
    *n = strc = 0;
    strv = NULL;
    return strv;
  }
  if ( getfname( dirname ) == NULL ){
    *n = strc = 0;
    return strv;
  }
#if defined(__BORLANDC__)||defined(__TURBOC__)
  for ( i=0; i<extlen; i++ ){
    extname[i] = toupper( extname[i] );
  }
#endif
  name = getfname( dirname );
  while ( name != NULL ){
    namelen = strlen( name );
    if ( extlen == 1 ){ /* ĥҤꤵʤϳĥҤʤե븡 */
      if ( strstr(name,extname) == NULL ){
        strc++;
      }
    }else{ /* ĥҤꤵƤϤγĥҤĥե򸡺 */
      if ( namelen >= extlen ){
        if ( strncmp(&name[namelen-extlen],extname,strlen(extname)) == 0 ){
          strc++;
        }
      }
    }
    name = getfname( NULL );
  }
  if ( strc == 0 ) {
    *n = strc;
    strv = NULL;
    return strv;
  }
  strv = (char**)malloc( strc*sizeof(char*) );
  name = getfname( dirname );
  i = 0;
  while ( name != NULL ){
    namelen = strlen( name );
    if ( extlen == 1 ){
      if ( strstr(name,extname) == NULL ){
        strv[i] = (char*)malloc( (namelen+1)*sizeof(char) );
        strcpy( strv[i], name );
        i++;
      }
    }else{
      if ( namelen >= extlen ){
        if ( strncmp(&name[namelen-extlen],extname,strlen(extname)) == 0 ){
          strv[i] = (char*)malloc( (namelen+1)*sizeof(char) );
          strcpy( strv[i], name );
          i++;
        }
      }
    }
    name = getfname( NULL );
  }
  sort_strings( strc, strv );
  *n = strc;
  return strv;
}

/*
 * ޥɥ饤ϥե̾¤Ӽؿ read_files( argc, argv, n )
 *
 * : argc, argv ޥɥ饤󥪥ץ
 * : ե̾¤, n ե
 */
static char **read_files( int argc, char *argv[], int *ret_filec )
{
  int i, c;
  static char **filev = NULL;
  static int filec = 0;
  FILE *fp;
#ifdef __MSDOS__
  struct ffblk sff;
  int rff;
#endif
  
  if ( filev != NULL ){
    for ( i=0; i<filec; i++ )
      free( filev[i] );
    free( filev );
  }
#ifndef __MSDOS__
  filec = 0;
  for ( i=1; i<argc; i++ ){
    fp = fopen( argv[i], "r" );
    if ( fp != NULL ){
      filec++;
      fclose( fp );
    }
  }
  if ( filec != 0 )
    filev = (char**)malloc( filec*sizeof(char*) );
  else{
    filev = NULL;
    *ret_filec = filec;
    return filev;
  }
  c = 0;
  for ( i=1; i<argc; i++ ){
    fp = fopen( argv[i], "r" );
    if ( fp != NULL ){
      filev[c] = (char*)malloc( (strlen(argv[i])+1)*sizeof(char) );
      strcpy( filev[c], argv[i] );
      c++;
      fclose( fp );
    }
  }
  *ret_filec = filec;
  return filev;
#else
  filec = 0;
  for ( i=1; i<argc; i++ ){
    rff = findfirst( argv[i], &sff, 0 );
    while ( rff == 0 ){
      fp = fopen( sff.ff_name, "r" );
      if ( fp != NULL ){
        filec++;
        fclose( fp );
      }
      rff = findnext( &sff );
    }
  }
  if ( filec != 0 )
    filev = (char**)malloc( filec*sizeof(char*) );
  else{
    filev = NULL;
    *ret_filec = filec;
    return filev;
  }
  c = 0;
  for ( i=1; i<argc; i++ ){
    rff = findfirst( argv[i], &sff, 0 );
    while ( rff == 0 ){
      fp = fopen( sff.ff_name, "r" );
      if ( fp != NULL ){
        filev[c] = (char*)malloc( (strlen(sff.ff_name)+1)*sizeof(char) );
        strcpy( filev[c], sff.ff_name );
        c++;
        fclose( fp );
      }
      rff = findnext( &sff );
    }
  }
  *ret_filec = filec;
  return filev;
#endif
}

/*
 * ޥɥ饤ϥե̾ؿ read_file( argc, argv )
 *
 * : argc, argv ޥɥ饤󥪥ץ
 * : ե̾
 */
static char *read_file( int argc, char *argv[] )
{
  int c;
  char **files;

  files = read_files( argc, argv, &c );
  if ( c != 0 )
    return files[0];
  else
    return NULL;
}

#endif /* _FILES_H_ */
