#
# jutils Make File < Makefile > for unix
#
# Target text utilities for pc and unix: jmskanji library for unix
#
# Copyright (c) 1993 Tokyo Denki University, Taiji Yamada
#
 BIN_DIR = $(HOME)/bin          # install directory of the utilities
      CC = gcc

INC_PATH = -I$(HOME)/include    # jctype.h, jstring.h in this directory
LIB_PATH = -L$(HOME)/lib        # libjmskanji.a in this directory

   LINKS = -ljmskanji

  CFLAGS = -DENABLE_VSSCANF

# -----------------------------------------------------------------------------

 HEADERS = escs.h files.h option.h strutil.h textutil.h timeutil.h jutil.h

 FILTERS = jc tosj tojis toeuc
   UTILS = cats totex tops

 TARGETS = $(FILTERS) $(UTILS)

.c: $(HEADERS)
	$(CC) $(CFLAGS) $@.c -o $@ -I. $(INC_PATH) $(LIB_PATH) $(LINKS)

all: $(TARGETS)

filters: $(FILTERS)

utils: $(UTILS)

install:
	install -d $(BIN_DIR)
	install -m 755 $(TARGETS) $(BIN_DIR)

clean:
	rm -rf $(TARGETS)
	rm -rf core *~
