/*
 * string utilities with MAXBUF definition < strutil.h >
 *
 * Ĺʸ桼ƥƥ
 *
 * Copyright (c) 1992-94 Tokyo Denki University, Taiji Yamada
 */
#ifndef _STRUTIL_H_
#define _STRUTIL_H_
#define MAXBUF 2048

#ifndef __JSTRING_H
# define jstrstr strstr
#endif
#ifndef __JCTYPE_H
# define iskanji(c) 0
# define iskanji2(c) 0
#endif

static char *strins( char *ptr, char *str )
{
  char buf[MAXBUF];
  
  strcpy( buf, ptr );
  ptr[0] = '\0';
  strcat( ptr, str );
  strcat( ptr, buf );
  ptr += strlen( str );
  return ptr;
}

static char *strdel( char *ptr, int n )
{
  char buf[MAXBUF];
  
  strcpy( buf, ptr+n );
  ptr[0] = '\0';
  strcat( ptr, buf );
  return ptr;
}

static char *strrpl( char *buf, char *str1, char *str2 )
{
  int len1 = strlen(str1), len2 = strlen(str2);
  unsigned char *ptr, rest[MAXBUF];

  if ( len1<len2 ){ /* insert */
    strcpy( rest, str2+len1 );
    ptr = jstrstr( buf, str1 );
    while ( ptr != NULL ){
      if ( !iskanji2(*ptr) || !iskanji(*(ptr+1)) ){
        memcpy( ptr, str2, len1 );
        ptr += len1;
        ptr = strins( ptr, rest );
        ptr = jstrstr( ptr, str1 );
      }else{
        ptr++;
        ptr = jstrstr( ptr, str1 );
      }
    }
  }else{ /* (len1>len2) delete */
    ptr = jstrstr( buf, str1 );
    while ( ptr != NULL ){
      if ( !iskanji2(*ptr) || !iskanji(*(ptr+1)) ){
        memcpy( ptr, str2, len2 );
        ptr += len2;
        ptr = strdel( ptr, len1-len2 );
        ptr = jstrstr( ptr, str1 );
      }else{
        ptr++;
        ptr = jstrstr( ptr, str1 );
      }
    }
  }
  return buf;
}

static void tab_space( char *buf, int tab_l )
{
  int i;
  unsigned char *ptr, spaces[80];

  ptr = jstrstr( buf, "\t" );
  while ( ptr != NULL ){
    strdel( ptr, 1 );
    for ( i=0; i<tab_l-((int)ptr-(int)buf)%tab_l; i++ )
      spaces[i] = ' ';
    spaces[i] = '\0';
    ptr = strins( ptr, spaces );
    ptr = jstrstr( ptr, "\t" );
  }
}

#endif
