
#define NAME "toeuc: copyleft 1991 Taiji Yamada\n"
#define THIS "kanji code converter to euc code for dos and unix.\n"
#define HELP "usage ... toeuc filename > output, toeuc < filename > output.\n"

#include <stdio.h>
#include <jstring.h>
#include <jctype.h>
#include <files.h>
#include <option.h>
#include <jutil.h>

void main( int argc, char *argv[] )
{
  int code;
  char buf[2048], buf2[5096];
  char *fn;
  FILE *fp;

  if ( scan_option(argc,argv,"-help") || scan_option(argc,argv,"/?") ){
    fprintf( stderr, NAME );
    fprintf( stderr, THIS );
    fprintf( stderr, HELP );
    exit( 0 );
  }
  if ( (fn=read_file(argc,argv)) != NULL ){
    /* In the case of file reading, the kanji code is checked exactly. */
    fp = fopen( fn, "r" );
    code = jfcode( fp );
    while ( fgets( buf, 2048, fp ) != NULL ){
      switch ( code ){
      case JCT_ANK: case JCT_EUC: strcpy( buf2, buf ); break;
      case JCT_SJ:  sj2euc( buf, buf2 ); break;
      case JCT_JIS: jis2euc( buf, buf2 ); break;
      }
      printf( "%s", buf2 );
    }
  }else{
    /* In the case of filter, the kanji code is checked not exactly. */
    fp = stdin;
    while ( fgets( buf, 2048, fp ) != NULL ){
      str2euc( buf, buf2 );
      printf( "%s", buf2 );
    }
  }
  exit( 0 );
}
