
#define THIS "tops ver.1.0 copyleft 1994 Taiji Yamada, aihara corporations\n"
#define HELP "\
* this is ...\n\
  command for making PostScript from files for msdos and unix.\n\
* usage ...\n\
  tops [options] file1 [file2...]\n\
* options ...\n\
  -a3/-a4/-a5/-b4/-b5: set paper size. default a4 size.\n\
  -tiny  : portrait,  two side,  84 chars, 150 lines, 0.18cm font.\n\
  -small : landscape, two side,  86 chars,  66 lines, 0.25cm font, default.\n\
  -normal: portrait,  one side,  86 chars,  86 lines, 0.28cm font.\n\
  -large : landscape, one side, 132 chars,  56 lines, 0.30cm font.\n\
  -n : print with line number, or -n 4: set char length of line number.\n\
  -t : change tab to space,    or -t 8: set tab columns, default on.\n\
  -c : set maximum number of chars a line, as follows: -c 90\n\
  -l : set maximum number of lines a page, as follows: -l 70\n\
  -ps: set width and height (cm) of paper, as follows: -ps 21.0x29.7\n\
  -fs: set size (cm) of base font,         as follows: -fs 0.20\n\
  -pr/-ls: portrait/landscape.      -1/-2: single/double side printing.\n\
  -nf/-bf: normal font and minchou kanji / bold font and gothic kanji.\n\
  -sj/-jis/-euc: output with kanji code. default sj on dos, euc on unix.\n\
  -help: show this help to standard output, or /? is enable.\n\
"
#define HELPJ "\
 ...\n\
  ե PostScript եѴ륳ޥ.\n\
Ȥ ...\n\
  tops [ץ] ե1 [ե2...]\n\
ץ ...\n\
  -a3/-a4/-a5/-b4/-b5: ѻΥ. ǥեA4.\n\
  -tiny  : ֤, 2,  84ʸ, 150, 0.18cm ե.\n\
  -small : ֤, 2,  86ʸ,  66, 0.25cm ե, ǥե.\n\
  -normal: ֤, 1,  86ʸ,  86, 0.28cm ե.\n\
  -large : ֤, 1, 132ʸ,  56, 0.30cm ե.\n\
  -n : ե˹ֹղ. -n 4: ֹη.\n\
  -t : ֤饹ڡѴ. -t 8: ֥. ǥեON.\n\
  -c : Ԥκʸ.     Τ褦˻ꤹ: -c 90\n\
  -l : ǤΥ饤.       Τ褦˻ꤹ: -l 70\n\
  -ps: ѻΥ(cm).   Τ褦˻ꤹ: -ps 21.0x29.7\n\
  -fs: եȥ(cm). Τ褦˻ꤹ: -fs 0.20\n\
  -pr/-ls: ѻ֤/֤.    -1/-2: 1/2.\n\
  -nf/-bf: Ρޥե,ī / ܡɥեȤӥå.\n\
  -sj/-jis/-euc: ϴ. ǥե եJIS:DOS, EUC:UNIX\n\
  -help: Υإפɽ. ⤷ /? Ǥͭ.\n\
"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <jctype.h>
#include <jstring.h>

#include <files.h>
#include <option.h>
#include <strutil.h>
#include <textutil.h>
#include <timeutil.h>
#include <jutil.h>

enum SIDES {
  ONE_SIDE,
  TWO_SIDE
};
int SIDE = TWO_SIDE; /* double side printing, or single side */

enum ORIENTS {
  PORTRAIT,
  LANDSCAPE
};
int ORIENT = LANDSCAPE; /* paper orientation */

int BASE_FONT_BOLD = 0; /* bold font or not */

int LINE_NUMB =  0, /* 0: without number, otherwise: with number   */
    TAB_SPACE =  8, /* 0: no exchange, otherwise: let tab to space */
    MAX_CHARS = 86, /* the number of characters a line             */
    MAX_LINES = 66; /* the number of lines a page                  */

float PAPER_WIDTH    = 21.0, /* paper width, centimeter   */
      PAPER_HEIGHT   = 29.7, /* paper height, centimeter  */
      BASE_FONT_SIZE = 0.25, /* typewriter-like font size */
      FILE_FONT_SIZE,        /* file name font size       */
      INFO_FONT_SIZE;        /* information font size     */

#ifdef __MSDOS__
int CODE = JCT_SJ;
#else
int CODE = JCT_EUC;
#endif
char *MINCHO[] = { /* kanji base font - minchou */
  "", "Ryumin-Light-SJ-H", "Ryumin-Light-H", "Ryumin-Light-EUC-H",
};
char *GOTHIC[] = { /* kanji base font - gothic */
  "", "GothicBBB-Medium-SJ-H", "GothicBBB-Medium-H", "GothicBBB-Medium-EUC-H",
};

int N_LINE = 0; /* termporal line number, it's need to page construction */

typedef struct _filter_mechanism {
  void (*begin)( void );
  void (*tof)( char* );
  void (*line)( int, char* );
  void (*eof)( void );
  void (*end)( void );
} filter_mechanism;

/*
 * Ԥؿ:  n: 饤ֹ, *line: ʸ
 *
 * ( 1) ֤ϥڡ֤.
 * ( 2) ֹղä.
 * ( 3) ʸۤ饤ԥɤʬ䤹.
 * (*) ʸϥեJISɤȤ.
 */
void normalize_line( int n, char *line )
{
  int c, max_chars;
  unsigned char *ptr, number[80], spaces[80];
  
  if ( TAB_SPACE )
    tab_space( line, TAB_SPACE );
  if ( LINE_NUMB ){
    sprintf( number, "%*d ", LINE_NUMB, n );
    strins( line, number );
    sprintf( spaces, "\n%*s", LINE_NUMB+1, " " );
  }else
    sprintf( spaces, "\n" );
  if ( MAX_CHARS )
    max_chars = MAX_CHARS + 1;
  else
    max_chars = strlen( line ) + 1;
  c = 1;
  ptr = line;
  while ( *ptr != '\0' ){
    if ( !(iskanji(*ptr)&&iskanji2(*(ptr+1))) ){
      if ( c%max_chars == 0 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
      }
      c++;
      ptr++;
    }else{
      if ( c%max_chars == 0 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
      }
      if ( c%max_chars == max_chars-1 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
	c++;
      }
      c += 2;
      ptr += 2;
    }
  }
}

/*
 * ݥȥץѥե륿³
 *   begin output        : print header
 *     tof (top of file) : print label
 *       line output     : print lines
 *     eof (end of file) : print new page
 *   end output          : print footer
 */
#define ps printf
void begin_ps( void )
{
  ps( "%%!\n" );
  ps( "%% output by %s", THIS );
  ps( "%% internal definition for Post Script\n" );
  ps( "%% thanks authors of k2ps, a2ps and dvi2ps\n" );

  ps( "/vmstate save def\n" );

  ps( "%% define macros -------------------------------------------------\n" );
  ps( "/xdef { exch def } bind def\n" );
  ps( "/inch { 72 mul } bind def\n" );
  ps( "/cm { 0.393707 mul inch } bind def\n" );

  ps( "%% define paper size ---------------------------------------------\n" );
  ps( "/paperwidth  %f cm def\n", PAPER_WIDTH  );
  ps( "/paperheight %f cm def\n", PAPER_HEIGHT );

  ps( "/filenamesize %f cm def\n", FILE_FONT_SIZE );
  ps( "/filenamefont {\n" );
  ps( "  /Times-Bold findfont filenamesize scalefont setfont\n" );
  ps( "} def\n" );
  ps( "/infofontsize %f cm def\n", INFO_FONT_SIZE );
  ps( "/infofont {\n" );
  ps( "  /Times-Roman findfont infofontsize scalefont setfont\n" );
  ps( "} def\n" );
  ps( "/headersize filenamesize 2 add def\n" );

  ps( "/basefontsize %f cm def\n", BASE_FONT_SIZE );
  ps( "/basefont {\n" );
  ps( "  /Courier%s findfont\n", BASE_FONT_BOLD?"-Bold":"" );
  ps( "  [basefontsize 0 0 basefontsize 0 0] makefont setfont\n" );
  ps( "} def\n" );

  ps( "/basefontwidth basefont ( ) stringwidth pop def\n" );
  ps( "/jbasefontwidth basefont (  ) stringwidth pop def\n" );

  ps( "/jbasefont {\n" );
  ps( "  /%s findfont\n", BASE_FONT_BOLD?GOTHIC[CODE]:MINCHO[CODE] );
  ps( "  [jbasefontwidth 0 0 basefontsize 0 0] makefont setfont\n" );
  ps( "} def\n" );

  ps( "%% page settings -------------------------------------------------\n" );
  ps( "/charsperline %d def\n", MAX_CHARS );
  ps( "/linesperpage %d def\n", MAX_LINES );
  ps( "/sidemargin 4 def\n" );
  ps( "/topmargin 4 def\n" );
  ps( "/pagewidth {\n" );  /* = charsize*chars + 2 sidemargin */
  ps( "  basefontwidth charsperline mul sidemargin dup add add\n" );
  ps( "} def\n" );
  ps( "/pageheight {\n" ); /* = charsize*lines + 2 topmargin + headersize */
  ps( "  basefontsize linesperpage mul topmargin dup \n" );
  ps( "add add headersize add } def\n" );

  switch ( ORIENT ){
  case PORTRAIT:
    switch ( SIDE ){
    case ONE_SIDE: /* normal */
      ps( "/uppery paperheight pageheight add 2 div def\n" );
      ps( "/upperx paperwidth pagewidth sub 2 div def\n" );
      break;
    case TWO_SIDE: /* tiny */
      ps( "/uppery paperheight pageheight add 2 div def\n" );
      ps( "/upperx\n" );
      ps( "  [paperwidth pagewidth 2 mul sub\n");
      ps( "  3 div dup 2 mul pagewidth add]\n");
      ps( "def\n" );
      break;
    }
    break;
  case LANDSCAPE: /* large */
    switch ( SIDE ){
    case ONE_SIDE:
      ps( "/uppery paperwidth pageheight add 2 div def\n" );
      ps( "/upperx paperheight pagewidth sub 2 div def\n" );
      break;
    case TWO_SIDE: /* small */
      ps( "/uppery paperwidth pageheight add 2 div def\n" );
      ps( "/upperx\n" );
      ps( "  [paperheight pagewidth 2 mul sub\n" );
      ps( "  3 div dup 2 mul pagewidth add]\n" );
      ps( "def\n" );
      break;
    }
    break;
  }

  ps( "%% for printing numbers ------------------------------------------\n" );
  ps( "/pnum 12 string def\n" );
  ps( "/empty 12 string def\n" );

  ps( "%% program structure ---------------------------------------------\n" );
  ps( "/newfile {\n" );
  ps( "  /filename xdef\n" );
  ps( "  /pagenum 1 def\n" );
  ps( "} bind def\n" );

  ps( "/startdoc {\n" );
  switch ( ORIENT ){
  case PORTRAIT:
    break;
  case LANDSCAPE:
    ps( "  paperwidth 0 inch translate\n" );
    ps( "  90 rotate\n" );
    break;
  }
  switch ( SIDE ){
  case ONE_SIDE:
    break;
  case TWO_SIDE:
    ps( "  /sheetside 0 def\n" );
    break;
  }
  ps( "  /sheet 1 def\n" );
  ps( "} bind def\n" );

  ps( "/cleanup {\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    break;
  case TWO_SIDE:
    ps( "  sheetside 1 eq {\n" );
    ps( "    /sheetside 0 def\n" );
    ps( "    numberpage\n" );
    ps( "    /sheet sheet 1 add def\n" );
    ps( "    copypage\n" );
    ps( "    erasepage\n" );
    ps( "  }\n" );
    ps( "  if\n" );
    break;
  }
  ps( "  vmstate restore\n" );
  ps( "} bind def\n" );

  ps( "/startpage {\n" );
  ps( "  printheader\n" );
  ps( "  printborder\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    ps( "  upperx sidemargin add\n" );
    ps( "  uppery topmargin sub basefontsize sub headersize sub moveto\n" );
    break;
  case TWO_SIDE:
    ps( "  upperx sheetside get sidemargin add\n" );
    ps( "  uppery topmargin sub basefontsize sub headersize sub moveto\n" );
    break;
  }
  ps( "  basefont\n" );
  ps( "} bind def\n" );

  ps( "/printheader {\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    ps( "  upperx uppery headersize sub 1 add moveto\n" );
    break;
  case TWO_SIDE:
    ps( "  upperx sheetside get uppery headersize sub 1 add moveto\n" );
    break;
  }
  ps( "  infofont\n" );
  ps( "  gsave\n" );
  ps( "  sidemargin 2 rmoveto date show\n" );
  ps( "  grestore\n" );
  ps( "  gsave\n" );
  ps( "  pagenum pnum cvs\n" );
  ps( "  pagewidth sidemargin sub pnum stringwidth pop sub\n" );
  ps( "  (p. ) stringwidth pop sub 3 rmoveto\n" );
  ps( "  (p. ) show pnum show\n" );
  ps( "  grestore\n" );
  ps( "  empty pnum copy\n" );
  ps( "  gsave\n" );
  ps( "  filenamefont\n" );
  ps( "  pagewidth filename stringwidth pop sub 2 div 2 rmoveto\n" );
  ps( "  filename show\n" );
  ps( "  grestore\n" );
  ps( "} bind def\n" );

  ps( "/printborder {\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    ps( "  upperx uppery moveto\n" );
    break;
  case TWO_SIDE:
    ps( "  upperx sheetside get uppery moveto\n" );
    break;
  }
  ps( "  0.5 setlinewidth gsave\n" );
  ps( "  pagewidth 0 rlineto\n" );
  ps( "  0 pageheight neg rlineto\n" );
  ps( "  pagewidth neg 0 rlineto\n" );
  ps( "  closepath stroke\n" );
  ps( "  grestore\n" );
  ps( "  0 headersize neg rmoveto pagewidth 0 rlineto stroke\n" );
  ps( "} bind def\n" );

  ps( "/endpage {\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    ps( "  numberpage\n" );
    ps( "  copypage\n" );
    ps( "  erasepage\n" );
    ps( "  /sheet sheet 1 add def\n" );
    break;
  case TWO_SIDE:
    ps( "  sheetside 1 eq {\n" );
    ps( "  /sheetside 0 def\n" );
    ps( "  numberpage\n" );
    ps( "  copypage\n" );
    ps( "  erasepage\n" );
    ps( "  /sheet sheet 1 add def\n" );
    ps( "  } {\n" );
    ps( "  /sheetside 1 def\n" );
    ps( "  } ifelse\n" );
    break;
  }
  ps( "  /pagenum pagenum 1 add def\n" );
  ps( "} bind def\n" );

  ps( "/numberpage {\n" );
  switch ( ORIENT ){
  case PORTRAIT:
    switch ( SIDE ){
    case ONE_SIDE: /* normal */
      ps( "  paperwidth upperx sub sidemargin add\n" );
      ps( "  paperheight uppery sub headersize sub moveto\n" );
      break;
    case TWO_SIDE: /* tiny */
      ps( "  paperwidth upperx 0 get sub sidemargin add\n" );
      ps( "  paperheight uppery sub headersize sub moveto\n" );
      break;
    }
    break;
  case LANDSCAPE:
    switch ( SIDE ){
    case ONE_SIDE: /* large */
      ps( "  paperheight upperx sub sidemargin add\n" );
      ps( "  paperwidth uppery sub headersize sub moveto\n" );
      break;
    case TWO_SIDE: /* small */
      ps( "  paperheight upperx 0 get sub sidemargin add\n" );
      ps( "  paperwidth uppery sub headersize sub moveto\n" );
      break;
    }
    break;
  }
  ps( "  infofont\n" );
  ps( "  sheet pnum cvs show\n" );
  ps( "  empty pnum copy\n" );
  ps( "} bind def\n" );
  
  ps( "/newline {\n" );
  switch ( SIDE ){
  case ONE_SIDE:
    ps( "  upperx sidemargin add\n" );
    break;
  case TWO_SIDE:
    ps( "  upperx sheetside get sidemargin add\n" );
    break;
  }
  ps( "  currentpoint exch pop basefontsize sub\n" );
  ps( "  moveto\n" );
  ps( "} bind def\n" );
  
  ps( "%% start all files -----------------------------------------------\n" );
  ps( "/date (%s) def\n", stamp_tm( NULL ) );
  ps( "startdoc\n" );
  ps( "/sheet 1 def\n" );
}
void tof_ps( char *label )
{
  printf( "(%s) newfile\n", label );
  printf( "startpage\n" );
}
void line_ps( int n, char *line )
{
  /*
   * \ -> \\, ( -> \(, ) -> \), KANJI -> CODE
   */
  unsigned char *ptr;
  int code, c;
  unsigned short sjc, jis, euc;

  normalize_line( n, line );
  code = JCT_ANK;
  if ( strcmp(line,"\n") == 0 ){
    ps( "newline\n" );
    N_LINE++;
    if ( N_LINE%MAX_LINES == 0 )
      ps( "endpage startpage\n" );
  }
  ptr = jstrtok( line, "\n" );
  while ( ptr != NULL ){
    ps( "(" );
    while ( *ptr != '\0' ){
      if ( !iskana(*ptr) && !(iskanji(*ptr)&&iskanji2(*(ptr+1))) ){
        if ( code == JCT_SJ )
          ps( "> show basefont\n(" );
        code = JCT_ANK;
        if ( *ptr == '\\' || *ptr == '(' || *ptr == ')' )
          ps( "%c", '\\' );
        ps( "%c", *ptr++ );
      }else{
        if ( code == JCT_ANK )
          ps( ") show jbasefont\n<" );
        else
          ps( " " );
        code = JCT_SJ;
        if ( iskana(*ptr) ){
          sjc = kana2zen(ptr,&c);
          ptr += c;
        }else{
          sjc = s2code(ptr);
          ptr += 2;
        }
        jis = jmstojis(sjc);
        euc = jistoeuc(jis);
        switch ( CODE ){
        case JCT_SJ:
          ps( "%x", sjc );
          break;
        case JCT_JIS:
          ps( "%x", jis );
          break;
        case JCT_EUC:
          ps( "%x", euc );
          break;
        }
      }
    }
    if ( code == JCT_ANK ){
      ps( ") show newline\n" );
    }else{
      ps( "> show basefont newline\n" );
    }
    N_LINE++;
    if ( N_LINE%MAX_LINES == 0 )
      ps( "endpage startpage\n" );
    ptr = jstrtok( NULL, "\n" );
  }
}
void eof_ps( void )
{
  ps( "endpage\n" );
  N_LINE = 0;
}
void end_ps( void )
{
  ps( "cleanup\n" );
  ps( "%% \n" );
  ps( "%% output by %s", THIS );
  ps( "%% internal definition for Post Script\n" );
  ps( "%% \n" );
}

filter_mechanism filter = {
  begin_ps, tof_ps, line_ps, eof_ps, end_ps
};

void usage( FILE *fp )
{
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
  fprintf( fp, THIS );
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
  if ( getenv( "LANG" ) != NULL && strcmp(getenv("LANG"),"japanese") == 0 )
    fprintf( fp, HELPJ );
  else
    fprintf( fp, HELP );
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
}

void option( int argc, char *argv[] )
{
  if (scan_option(argc,argv,"-a3")){ PAPER_WIDTH = 29.7; PAPER_HEIGHT = 42.0; }
  if (scan_option(argc,argv,"-a4")){ PAPER_WIDTH = 21.0; PAPER_HEIGHT = 29.7; }
  if (scan_option(argc,argv,"-a5")){ PAPER_WIDTH = 14.8; PAPER_HEIGHT = 21.0; }
  if (scan_option(argc,argv,"-b4")){ PAPER_WIDTH = 25.7; PAPER_HEIGHT = 36.4; }
  if (scan_option(argc,argv,"-b5")){ PAPER_WIDTH = 18.2; PAPER_HEIGHT = 25.7; }
  if ( scan_option(argc,argv,"-tiny") ){
    ORIENT = PORTRAIT;  SIDE = TWO_SIDE; MAX_CHARS =  84; MAX_LINES = 150;
    BASE_FONT_SIZE = 0.18;
  }
  if ( scan_option(argc,argv,"-small") ){
    ORIENT = LANDSCAPE; SIDE = TWO_SIDE; MAX_CHARS =  86; MAX_LINES =  66;
    BASE_FONT_SIZE = 0.25;
  }
  if ( scan_option(argc,argv,"-normal") ){
    ORIENT = PORTRAIT;  SIDE = ONE_SIDE; MAX_CHARS =  86; MAX_LINES =  86;
    BASE_FONT_SIZE = 0.28;
  }
  if ( scan_option(argc,argv,"-large") ){
    ORIENT = LANDSCAPE; SIDE = ONE_SIDE; MAX_CHARS = 132; MAX_LINES =  56;
    BASE_FONT_SIZE = 0.30;
  }
  if ( scan_option(argc,argv,"-n %d",&LINE_NUMB) )
    if ( LINE_NUMB <= 0 ) LINE_NUMB = 4;
  if ( scan_option(argc,argv,"-t %d",&TAB_SPACE) )
    if ( TAB_SPACE <= 1 ) TAB_SPACE = 8;
  if ( scan_option(argc,argv,"-c %d",&MAX_CHARS) )
    if ( MAX_CHARS <= 0 ) MAX_CHARS = 90;
  if ( scan_option(argc,argv,"-l %d",&MAX_LINES) )
    if ( MAX_LINES <= 0 ) MAX_LINES = 70;
  scan_option(argc,argv,"-ps %fx%f",&PAPER_WIDTH,&PAPER_HEIGHT);
  scan_option(argc,argv,"-fs %f",   &BASE_FONT_SIZE);
  if ( scan_option(argc,argv,"-1") ) SIDE = ONE_SIDE;
  if ( scan_option(argc,argv,"-2") ) SIDE = TWO_SIDE;
  if ( scan_option(argc,argv,"-nf") ) BASE_FONT_BOLD = 0;
  if ( scan_option(argc,argv,"-bf") ) BASE_FONT_BOLD = 1;
  if ( scan_option(argc,argv,"-pr") ) ORIENT = PORTRAIT;
  if ( scan_option(argc,argv,"-ls") ) ORIENT = LANDSCAPE;
  if ( scan_option(argc,argv,"-sj")  ) CODE = JCT_SJ;
  if ( scan_option(argc,argv,"-jis") ) CODE = JCT_JIS;
  if ( scan_option(argc,argv,"-euc") ) CODE = JCT_EUC;
  if ( scan_option(argc,argv,"-help" ) || scan_option(argc,argv,"/?") ){
    usage( stdout );
    exit( 0 );
  }
  FILE_FONT_SIZE = BASE_FONT_SIZE*7/5;
  INFO_FONT_SIZE = BASE_FONT_SIZE*6/5;
}

void main( int argc, char *argv[] )
{
  int i, filec, l;
  char *ptr, **files, buf[MAXBUF];
  FILE *fp;

  option( argc, argv );
  setjcode( JCT_SJ );
  files = read_files( argc, argv, &filec );
  if ( filec == 0 ){
    usage( stderr );
    exit( 1 );
  }
  filter.begin();
  for ( i=0; i<filec; i++ ){
    fp = fopen( files[i], "r" );
    if ( fp != NULL ){
      l = 1;
      filter.tof( files[i] );
      while ( jfgets( buf, MAXBUF, fp ) != NULL ){
        if ( jstrstr(buf,"\n") == NULL )
          strcat( buf, "\n" );
        filter.line( l, buf );
        l++;
      }
      fclose( fp );
      filter.eof();
    }
  }
  filter.end();
  exit( 0 );
}
