
#define THIS "totex ver.1.0 copyleft 1994 Taiji Yamada, aihara corporations\n"
#define HELP "\
* this is ...\n\
  command for making LaTeX file for msdos and unix.\n\
* usage ...\n\
  totex [options] file1 [file2...]\n\
* options ...\n\
  -i : build insertable TeX file, default compilable full LaTeX.\n\
  -n : print with line number, or -n 4: set char length of line number.\n\
  -t : change tab to space,    or -t 8: set tab columns, default on.\n\
  -c : set maximum number of chars a line, as follows: -c 79, default 0 off.\n\
  -help: show this help to standard output, or /? is enable.\n\
* kanji code options ...\n\
  -sj : output with shift jis kanji code. default on dos.\n\
  -jis: output with jis code kanji code.\n\
  -euc: output with euc kanji code. default on unix.\n\
"
#define HELPJ "\
 ...\n\
  ե LaTeX եѴ륳ޥ.\n\
Ȥ ...\n\
  totex [ץ] ե1 [ե2...]\n\
ץ ...\n\
  -i : ǽTeXեκ. ǥեȤϥѥǽʥե.\n\
  -n : ե˹ֹղ. -n 4: ֹη.\n\
  -t : ֤饹ڡѴ. -t 8: ֥. ǥեON.\n\
  -c : Ԥκʸ. Τ褦˻ꤹ: -c 90. ǥե 0 OFF.\n\
  -help: Υإפɽ. ⤷ /? Ǥͭ.\n\
ɥץ ...\n\
  -sj : եJISǽ. DOSǥե.\n\
  -jis: JISɤǽ.\n\
  -euc: EUCɤǽ. UNIXǥե.\n\
"
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <jctype.h>
#include <jstring.h>

#include <files.h>
#include <option.h>
#include <strutil.h>
#include <textutil.h>
#include <timeutil.h>
#include <jutil.h>

int LINE_NUMB = 0, /* 0: without number, otherwise: with number   */
    TAB_SPACE = 8, /* 0: no exchange, otherwise: let tab to space */
    MAX_CHARS = 0; /* the number of characters a line, 0: no max  */

#ifdef __MSDOS__
int CODE = JCT_SJ;
#else
int CODE = JCT_EUC;
#endif

typedef struct _filter_mechanism {
  void (*begin)( void );
  void (*tof)( char* );
  void (*line)( int, char* );
  void (*eof)( void );
  void (*end)( void );
} filter_mechanism;

/*
 * Ԥؿ:  n: 饤ֹ, *line: ʸ
 *
 * ( 1) ֤ϥڡ֤.
 * ( 2) ֹղä.
 * ( 3) ʸۤ饤ԥɤʬ䤹.
 * (*) ʸϥեJISɤȤ.
 */
void normalize_line( int n, char *line )
{
  int c, max_chars;
  unsigned char *ptr, number[80], spaces[80];
  
  if ( TAB_SPACE )
    tab_space( line, TAB_SPACE );
  if ( LINE_NUMB ){
    sprintf( number, "%*d ", LINE_NUMB, n );
    strins( line, number );
    sprintf( spaces, "\n%*s", LINE_NUMB+1, " " );
  }else
    sprintf( spaces, "\n" );
  if ( MAX_CHARS )
    max_chars = MAX_CHARS + 1;
  else
    max_chars = strlen( line ) + 1;
  c = 1;
  ptr = line;
  while ( *ptr != '\0' ){
    if ( !(iskanji(*ptr)&&iskanji2(*(ptr+1))) ){
      if ( c%max_chars == 0 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
      }
      c++;
      ptr++;
    }else{
      if ( c%max_chars == 0 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
      }
      if ( c%max_chars == max_chars-1 ){
	ptr = strins( ptr, spaces );
	c += strlen( spaces );
	c++;
      }
      c += 2;
      ptr += 2;
    }
  }
}

/*
 * LaTeXѥե륿³
 *   begin output        : \documentstyle..\begin{document}
 *     tof (top of file) : print label
 *       line output     : print lines
 *     eof (end of file) : print new page
 *   end output          : \end{document}
 */
void begin_tex( void )
{
  char *text[] = {
    "% \n",
    "% output by ", THIS,
    "% internal definition for LaTeX\n",
    "% \n",
    "\\documentstyle{jarticle}\n",
    "\\setlength{\\topmargin}{0cm}\n",
    "\\setlength{\\oddsidemargin}{0cm}\n",
    "\\setlength{\\evensidemargin}{0cm}\n",
    "\\setlength{\\textheight}{23cm}\n",
    "\\setlength{\\textwidth}{16cm}\n",
    "\\begin{document}\n",
    "\\small\\tt\n",
    NULL,
  };

  text_printf( text );
}
void begin_itex( void )
{
  /* do nothing */
}
void modify_line_tex( char *buf )
{
  static char MAGIC = 0x3, *MAGICS = "%c%s%c";
  char MAGIC_BS[16];

  /* for tex control char magics */
  sprintf( MAGIC_BS, MAGICS, MAGIC, "bs", MAGIC );
  /* for tex control char */
  strrpl( buf, "\\", MAGIC_BS );
  strrpl( buf, "{",  "\\{" );
  strrpl( buf, "}",  "\\}" );
  strrpl( buf, "^",  "\\^{}" );
  strrpl( buf, "_",  "\\_{}" );
  strrpl( buf, "&",  "\\&" );
  strrpl( buf, "$",  "\\$" );
  strrpl( buf, "#",  "\\#" );
  strrpl( buf, "%",  "\\%" );
  strrpl( buf, "~",  "\\~" );
  strrpl( buf, " ",  "~" );
  strrpl( buf, MAGIC_BS, "$\\backslash$" );
  strrpl( buf, "\n", "\\\\" );
  /* for tex flushleft */
  if ( strcmp( buf, "\\\\" ) == 0 ) strins( buf, "~" );
}
void tof_tex( char *label )
{
  char label2[64];

  if ( label != NULL ){
    strcpy( label2, label );
    modify_line_tex( label2 );
    printf( "\\begin{flushleft}\n" );
    printf( "\\fbox{%s}\n", label2 );
    printf( "\\end{flushleft}\n" );
  }
  printf( "\\begin{flushleft}\n" );
}
void line_tex( int n, char *line )
{
  unsigned char *ptr;
  int kanji_code = getjcode();

  setjcode( CODE );
  normalize_line( n, line ); modify_line_tex( line );
  ptr = jstrtok( line, "\n" );
  while ( ptr != NULL ){
    jputs( ptr ); printf( "\n" );
    ptr = jstrtok( NULL, "\n" );
  }
  setjcode( kanji_code );
}
void eof_tex( void )
{
  printf( "\\end{flushleft}\n" );
  printf( "\\newpage\n" );
}
void end_tex( void )
{
  char *text[] = {
    "% \n",
    "% output by ", THIS,
    "% internal definition for LaTeX\n",
    "% \n",
    "\\end{document}\n",
    NULL,
  };

  text_printf( text );
}
void end_itex( void )
{
  /* do nothing */
}

filter_mechanism filter = {
  begin_tex, tof_tex, line_tex, eof_tex, end_tex
};

void usage( FILE *fp )
{
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
  fprintf( fp, THIS );
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
  if ( getenv( "LANG" ) != NULL && strcmp(getenv("LANG"),"japanese") == 0 )
    fprintf( fp, HELPJ );
  else
    fprintf( fp, HELP );
  fprintf( fp, "\
---------------------------------------------------------------------------\n\
" );
}

void option( int argc, char *argv[] )
{
  if ( scan_option(argc,argv,"-i") ){
    filter.begin = begin_itex;
    filter.end   = end_itex;
  }
  if ( scan_option(argc,argv,"-n %d",&LINE_NUMB) )
    if ( LINE_NUMB <= 0 ) LINE_NUMB = 4;
  if ( scan_option(argc,argv,"-t %d",&TAB_SPACE) )
    if ( TAB_SPACE <= 1 ) TAB_SPACE = 8;
  if ( scan_option(argc,argv,"-c %d",&MAX_CHARS) )
    if ( MAX_CHARS <= 0 ) MAX_CHARS = 0;
  if ( scan_option(argc,argv,"-sj")  ) CODE = JCT_SJ;
  if ( scan_option(argc,argv,"-jis") ) CODE = JCT_JIS;
  if ( scan_option(argc,argv,"-euc") ) CODE = JCT_EUC;
  if ( scan_option(argc,argv,"-help" ) || scan_option(argc,argv,"/?") ){
    usage( stdout );
    exit( 0 );
  }
}

void main( int argc, char *argv[] )
{
  int i, filec, l;
  char *ptr, **files, buf[MAXBUF];
  FILE *fp;

  option( argc, argv );
  setjcode( JCT_SJ );
  files = read_files( argc, argv, &filec );
  if ( filec == 0 ){
    usage( stderr );
    exit( 1 );
  }
  filter.begin();
  for ( i=0; i<filec; i++ ){
    fp = fopen( files[i], "r" );
    if ( fp != NULL ){
      l = 1;
      filter.tof( files[i] );
      while ( jfgets( buf, MAXBUF, fp ) != NULL ){
        if ( jstrstr(buf,"\n") == NULL )
          strcat( buf, "\n" );
        filter.line( l, buf );
        l++;
      }
      fclose( fp );
      filter.eof();
    }
  }
  filter.end();
  exit( 0 );
}
