#include <stdio.h>
#include <graphics.h>
#include <graphics/outtext.h>

int line_width = 1;
int line_color = 0;

int pressed_flag = 0;
int start_x, start_y;
int button_press( int b, int x, int y )
{
  if ( b == 1 && !pressed_flag ){
    pressed_flag = !0;
    start_x = x;
    start_y = y;
  }
  if ( b == 1 && pressed_flag ){
    setcolor( line_color );
    line( start_x, start_y, x, y );
    pressed_flag = !0;
    start_x = x;
    start_y = y;
  }
  if ( b == 3 )
    pressed_flag = 0;
  return !0;
}
int button_release( int b, int x, int y )
{
  return !0;
}
int mouse_motion( int b, int x, int y )
{
  static char mouse_info[64] = "640,480";

  setcolor( BLACK );
  setfillstyle( SOLID_FILL, WHITE );
  bar( 0, 0, textwidth(mouse_info), textheight(mouse_info) );
  sprintf( mouse_info, "%3d,%3d", x, y );
  outtextxy( 0, 0, mouse_info );
  return !0;
}
int key_press( int c )
{
  switch ( (char)c ){
  case '8': line_width = min(line_width+1,10); break;
  case '2': line_width = max( 0,line_width-1); break;
  case '6': line_color = min(line_color+1,14); break;
  case '4': line_color = max( 1,line_color-1); break;
  case 0x1b: return 0;
  }
  setlinestyle( SOLID_LINE, 0, line_width );
  setcolor( line_color );
  return !0;
}
int configure( void )
{
  int width, height;

  getsizexy( &width, &height );
  setsizexy(  width , height );
  cleardevice();
  pressed_flag = 0;
  return !0;
}
main()
{
  int gd = DETECT, gm;
  
  initgraph( &gd, &gm, "" );
  setcolor  ( BLACK );
  setbkcolor( WHITE );
  setlinestyle( SOLID_LINE, 0, line_width );
  cleardevice();
  set_button_press_proc  ( button_press   );
  set_button_release_proc( button_release );
  set_mouse_motion_proc  ( mouse_motion   );
  set_key_press_proc     ( key_press      );
  set_configure_proc     ( configure      );
  set_noevent_proc       ( NULL           );
  xbgiloop();
}
