#include <stdio.h>
#include <string.h>
#include <math.h>
#include <graphics.h>
#include <graphr2_.h>

int mycolor[16][3]={
  {  0,  0,  0 },
  {  0,  0,  2 },
  {  0,  0,  4 },
  {  0,  0,  6 },
  {  0,  0,  8 },
  {  0,  0, 10 },
  {  0,  0, 12 },
  {  0,  0, 14 },
  {  0, 10, 15 },
  {  0,  8, 11 },
  {  0,  6,  7 },
  {  2,  4,  3 },
  {  4,  2,  0 },
  {  6,  0,  0 },
  {  8,  0,  0 },
  { 10,  0,  0 },
};
int WIDTH = 500;
int BSTEP =   1;
int MAXIT =  50;

void MandelSet( void )
{
  int    i, j, it;
  double x, y, zx, zy, u, v;

  for ( i=0; i<WIDTH; i+=BSTEP ){
    u = vwx( i + BSTEP/2 );
    for ( j=0; j<WIDTH; j+=BSTEP ){
      v = vwy( j + BSTEP/2 );
      x = 0.0;
      y = 0.0;
      for ( it=0; it<MAXIT; it++ ){
        zx = x*x - y*y + u;
        zy =  2.0*x*y  + v;
        x = zx;
        y = zy;
        if ( ( x*x + y*y ) > 10.0 )
          break;
      }
      setfillstyle( SOLID_FILL, ( MAXIT-it )%16 );
      bar( i, j, i+BSTEP-1, j+BSTEP-1 );
    }
  }
}

void main( void )
{
  int gd = DETECT, gm, gmxx, gmxy, c;
  double rstart = -2.1, istart = 1.2, rend = 0.5, iend = -1.2;

  initgraph_( &gd, &gm, "-geometry 500x500" );
  cleardevice();
  for( c=0; c<16; c++ ){
    setrgbpalette( c, mycolor[c][0], mycolor[c][1], mycolor[c][2] );
  }
  setcolor( 15 );
  setbkcolor( 0 );
  cleardevice();
  gmxx = getmaxx();
  gmxy = getmaxy();
  setviewport_( 0, 0, gmxx, gmxy, !0 );
  setwindow_( rstart, istart, rend, iend );
  printf( "x: from %8.5lf to %8.5lf\n", rstart, rend );
  printf( "y: from %8.5lf to %8.5lf\n", istart, iend );
  MandelSet();
  xbgiloop();
  closegraph_();
}
