#include <stdio.h>
#include <math.h>
#include <graphics.h>
#include <graphp3_.h>
void sponge( int n, double x, double y, double z, double l )
{
  int i, j, k;
  int c[3];

  if ( n < 0 )
    return;
  c[0] = c[1] = (10+n)%16; c[2] = (10+n)%16 - 8;
  boxp3_( x+l/6, y+l/6, z+l/6, x-l/6, y-l/6, z-l/6, c );
  for ( i=-1; i<2; i+=1 )
    for ( j=-1; j<2; j+=1 )
      for ( k=-1; k<2; k+=1 )
	if ( i!=0 || j!=0 || k!=0 )
	  sponge( n-1, x+l/3*i, y+l/3*j, z+l/3*k, l/3 );
}
void main( void )
{
  int gd = DETECT, gm;
  int n = 2, c = 'r';
  double x = 0, y = 0, z = 0, l = 1;
  int ROTX = -15, ROTY = 10, ROTZ = 0;
  double SX = 0.0, SY = 0.0;
  double DST = 0.2;

  initgraph_( &gd, &gm, "c:/borlandc/bgi" );
  setmaxx( 256-1 );
  setmaxy( 256-1 );
  settitle( "sponge" );
  cleardevice();

  do {
    switch( c ) {
    case 'r': cleardevice(); break;
    case '2': ROTX -= 5; ROTX = (ROTX+360)%360; break;
    case '8': ROTX += 5; ROTX = (ROTX+360)%360; break;
    case '4': ROTY += 5; ROTY = (ROTY+360)%360; break;
    case '6': ROTY -= 5; ROTY = (ROTY+360)%360; break;
    case '5': ROTX = ROTY = 0.0; break;
    case 'x': SY -= 0.05; break;
    case 'e': SY += 0.05; break;
    case 's': SX -= 0.05; break;
    case 'd': SX += 0.05; break;
    case 'c': SX = SY = 0.0; break;
    case 'f': DST *= 0.9; break;
    case 'b': DST *= 1.1; break;
    case 'g': DST  = 0.2; break;
    case 'n': n = min(n+1,3); break;
    case 'p': n = max(0,n-1); break;
    }
    switch( c ){
    case 'r':
    case '2': case '8': case '4': case '6': case '5':
    case 'x': case 'e': case 's': case 'd': case 'c':
    case 'f': case 'g': case 'b':
    case 'n': case 'p':
      setviewport_( 0, 0, 255, 255, !0 );
      setwindow_( -1.0-SX, 1.0-SY, 1.0-SX, -1.0-SY );
      setrotationport_( -1, -1, -1, 1, 1, 1 );
      setrotation_( RAD(ROTX), RAD(ROTY), RAD(ROTZ) );
      setdistance_( DST );
      cleardevice();
      sponge( n, x, y, z, l ); 
      break;
    }
  } while ( (c=getch()) != 0x1b );
  closegraph();
}

