#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <sys/file.h>
#include <ctype.h>
#include <X11/Xlib.h>
#include <xview/xview.h>
#include <xview/panel.h>
#include <xview/tty.h>
#include <xview/termsw.h>
#include <xview/textsw.h>
#include <xview/scrollbar.h>
#include <xview/notice.h>
#include <xview/cms.h>
#include <graphics.h>
#include <graphix.h>
#include <graphp3_.h>
#include "sponge.h"

void XVBGI_driver( void )
{
  extern xbgi *XBGI;
  XSetWindowAttributes att;

  XBGI->dpy = (Display*)xv_get(BasePanel,XV_DISPLAY);
  XBGI->scr = DefaultScreen( XBGI->dpy );
  XBGI->depth = DefaultDepth( XBGI->dpy, XBGI->scr );
  XBGI->colormap = DefaultColormap( XBGI->dpy, XBGI->scr );
  XBGI->ncolor = 16;
  XBGI->color = 15;
  XBGI->palette.size = (unsigned char)(XBGI->ncolor-1);
  XBGI->bkcolor = 0;
  XBGI->npage = 1;
  XBGI->apage = 0;
  XBGI->vpage = 0;
  XBGI->only_ank_flag = 0;
  XBGI->root = XCreateSimpleWindow( XBGI->dpy, RootWindow(XBGI->dpy,XBGI->scr),
                                   0, 0, 200, 200, 0,
                                   WhitePixel(XBGI->dpy,XBGI->scr),
                                   BlackPixel(XBGI->dpy,XBGI->scr) );
  XSelectInput( XBGI->dpy, XBGI->root, ExposureMask|StructureNotifyMask );
  XBGI->win = (Window*)malloc( XBGI->npage*sizeof(Window) );
  XBGI->win[0] = XCreateSimpleWindow( XBGI->dpy, XBGI->root, 0, 0,
				     200, 200, 0,
				     WhitePixel(XBGI->dpy,XBGI->scr),
				     BlackPixel(XBGI->dpy,XBGI->scr) );
  att.backing_store = Always;
  XChangeWindowAttributes( XBGI->dpy, XBGI->win[0], CWBackingStore, &att );
  XBGI->gcdraw  = XCreateGC( XBGI->dpy, XBGI->root, 0, NULL );
  XBGI->gcfill  = XCreateGC( XBGI->dpy, XBGI->root, 0, NULL );
  XBGI->gcpixel = XCreateGC( XBGI->dpy, XBGI->root, 0, NULL );
  XBGI->gcimage = XCreateGC( XBGI->dpy, XBGI->root, 0, NULL );

  detectgraph( &(XBGI->gdriver), &(XBGI->gmode) );
  setgraphmode( XBGI->gmode );
  graphdefaults();
  
  XMapWindow( XBGI->dpy, XBGI->root );
  XMapSubwindows( XBGI->dpy, XBGI->root ); 
  XFlush( XBGI->dpy );
  XBGI->gerror = grOk;
}
void sponge( int n, double x, double y, double z, double l )
{
  int i, j, k;
  int c[3];

  if ( n < 0 )
    return;
  c[0] = c[1] = (10+n)%16; c[2] = (10+n)%16 - 8;
  boxp3_( x+l/6, y+l/6, z+l/6, x-l/6, y-l/6, z-l/6, c );
  for ( i=-1; i<2; i+=1 )
    for ( j=-1; j<2; j+=1 )
      for ( k=-1; k<2; k+=1 )
	if ( i!=0 || j!=0 || k!=0 )
	  sponge( n-1, x+l/3*i, y+l/3*j, z+l/3*k, l/3 );
}

double x = 0, y = 0, z = 0, l = 1;
int n = 1, ROTX = -15, ROTY = 10, ROTZ = 0;
double SX = 0.0, SY = 0.0;
double DST = 0.2;

void do_drawing( void )
{
  int gd = DETECT, gm;
  static int first = !0;

  if ( first ){
    registerbgidriver( XVBGI_driver );
    initgraph( &gd, &gm, "-geometry 200x200+200+200" );
    first = 0;
  }
  setviewport_( 0, 0, getmaxx(), getmaxy(), !0 );
  setwindow_( -1.0-SX, 1.0-SY, 1.0-SX, -1.0-SY );
  setrotationport_( -1, -1, -1, 1, 1, 1 );
  setrotation_( RAD(ROTX), RAD(ROTY), RAD(ROTZ) );
  setdistance_( DST );
  cleardevice();
  sponge( n, x, y, z, l );
  xflush();
}

main(argc,argv)
int argc;
char *argv[];
{
  int gd = DETECT, gm;

  xv_init(XV_INIT_ARGC_PTR_ARGV,&argc,argv,
#ifdef JLE
	  XV_USE_LOCALE, TRUE,
	  /******XV_LC_DISPLAY_LANG, "japanese",
	    XV_LC_INPUT_LANG, "japanese",******/
#endif
	  NULL);
  
#include "sponge.code"
  
  xv_main_loop(BASE_FRAME);
  exit(0);
}

int Button_Left_Proc(item,event)
Panel_item item;
Event *event;
{
  ROTY += 5; ROTY = (ROTY+360)%360;
  do_drawing();
  auto_connect(item,event);
}

int Button_Right_Proc(item,event)
Panel_item item;
Event *event;
{
  ROTY -= 5; ROTY = (ROTY+360)%360;
  do_drawing();
  auto_connect(item,event);
}

int Button_Up_Proc(item,event)
Panel_item item;
Event *event;
{
  ROTX += 5; ROTX = (ROTX+360)%360;
  do_drawing();
  auto_connect(item,event);
}

int Button_Down_Proc(item,event)
Panel_item item;
Event *event;
{
  ROTX -= 5; ROTX = (ROTX+360)%360;
  do_drawing();
  auto_connect(item,event);
}

int Button_Quit_Proc(item,event)
Panel_item item;
Event *event;
{
  auto_connect(item,event);
  exit( 0 );
}

int Button_Fore_Proc(item,event)
Panel_item item;
Event *event;
{
  DST *= 0.9;
  do_drawing();
  auto_connect(item,event);
}

int Button_Back_Proc(item,event)
Panel_item item;
Event *event;
{
  DST *= 1.1;
  do_drawing();
  auto_connect(item,event);
}

int Button_Draw_Proc(item,event)
Panel_item item;
Event *event;
{
  do_drawing();
  auto_connect(item,event);
}
